CREATE TABLE [dbo].[Bookstore_Books] (
	[Id] [numeric](18, 0) NOT NULL ,
	[CategoryId] [numeric](18, 0) NOT NULL ,
	[Title] [varchar] (500) NOT NULL ,
	[Author] [varchar] (500) NOT NULL ,
	[Description] [varchar] (500) NULL ,
	[Icon] [varchar] (250) NULL ,
	[URL] [varchar] (2000) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Bookstore_Categories] (
	[Id] [numeric](18, 0) NOT NULL ,
	[ParentId] [numeric](18, 0) NULL ,
	[Name] [varchar] (250) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Bookstore_Books] WITH NOCHECK ADD 
	CONSTRAINT [PK_Bookstore_Books] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Bookstore_Categories] WITH NOCHECK ADD 
	CONSTRAINT [PK_Categories] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Bookstore_Books] ADD 
	CONSTRAINT [FK_Bookstore_Books_Bookstore_Categories] FOREIGN KEY 
	(
		[CategoryId]
	) REFERENCES [dbo].[Bookstore_Categories] (
		[Id]
	) ON DELETE CASCADE  ON UPDATE CASCADE 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE TRIGGER [Category_DeleteTree] ON [dbo].[Bookstore_Categories] 
FOR DELETE 
AS
 IF @@rowcount = 0 RETURN
 delete from Bookstore_Categories
 where ParentId in (select id from deleted)
 and not id in (select id from deleted)



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

